/////////////////////////////////////////////////////////
// Class	    	:   BlackJack
// Author	    	:	F. Meyer
// Description	    :   - main program
//						- initilisation : everything is created
//						from here
// Last Modified    :	03.02.1998
/////////////////////////////////////////////////////////

import java.applet.Applet;
import java.awt.*;

public class BlackJack extends Applet {

	private CardLayout cardManager;
	private Panel p1, p2;
	private BGame gameArea;
	private Canvas temp;
	private Button game, stat;
	
	private BRLPanel brlp;
	
	
	
	//////////////////////////////////////////////////////
	// Method		:   init
	// Descrition	:   - starting point of the applet
	//		    		- initialisation of the two main parts
	//						* the game
	//						* the learning algorithm
	//		    		- loading of the cards
	//////////////////////////////////////////////////////

	public void init () {

		int i;
		Image im;
		
		// Size of the applet window
		resize(600, 400);
		
		setLayout(null);
		setBackground(Color.white);
		
		// Load the images
		Cards.card = new Image [Cards.number];
		for (i=0; i<Cards.number; i++) {
			im = getImage( getDocumentBase(),
			"images/"+(i/13)+"-"+(i%13+1)+".gif");
			Cards.card[i] = im;
		}
		im = getImage ( getDocumentBase(),
				"images/00.gif");
		Cards.back = im;

		// Create the game table
		p1 = new Panel();
		p1.resize(500, 400);
		p1.move(100, 0);
		cardManager = new CardLayout();
		p1.setLayout(cardManager);
		add("East", p1);
		gameArea = new BGame(this);	// new Game area
		p1.add("Game Area", gameArea);
		
		// Create the area with learn options and commands
		brlp = new BRLPanel(this);
		p1.add("RL Panel", brlp);
		cardManager.last(p1);
		
		// Create the buttons for navigation between game and learning
		game = new Button("Play");
		stat = new Button("Learn");
		p2 = new Panel();
		p2.resize(100, 400);
		p2.move(0, 0);
		p2.setLayout(new GridLayout(10, 1, 8, 8));
		p2.setBackground(Color.white);
		p2.add("Center", game);
		p2.add("Center", stat);
		add("West", p2);
	}



	//////////////////////////////////////////////////////
	// Method		:   action
	// Descrition	:   - handle mouse down events
	//		    		- display corresponding part of program
	//////////////////////////////////////////////////////

	public boolean action(Event e, Object o) {
		// button game is pressed -> show the game panel
		if (e.target == game)
			cardManager.first(p1);
			
		// button stat pressed -> show the learning panel
		else if (e.target == stat)
			cardManager.last(p1);
		return true;
	}

	//////////////////////////////////////////////////////
	// Method	:   paint
	// Descrition	:   draw the game area in the game panel
	// In		:   
	// Out		:   
	public void paint(Graphics g) {
		gameArea.repaint();
	}

	//////////////////////////////////////////////////////
	// Method	:   
	// Descrition	:   
	// In		:   
	// Out		:   
}
